#! /usr/bin/env python

from distutils.core import setup
from distutils import sysconfig
import os

def get_data_files():
	dest = sysconfig.get_python_lib() + "/sfdownloader"
	res = [(dest,["src/README","src/AUTHORS","src/GPL","src/sfdownloader.glade","src/LICENSE"])]
	res.append((dest + "/data",["src/data/distros.conf","src/data/mirrors"]))
	temp = []
	for x in os.listdir("src/img"):
		temp.append("src/img/%s" % x)
	res.append((dest+"/img",temp))
	
	for x in os.listdir("src/lang"):
		lang = x
		temp = ["src/lang/%s/LC_MESSAGES/SFDownloader.mo" % x]
		res.append((dest+"/lang/%s/LC_MESSAGES" % x,temp))

	return res
	
def add_to_menu():
	print "Adding menu item."
	dest = sysconfig.get_python_lib() + "/sfdownloader"
	desktop = "[Desktop Entry]\nName=SFDownloader\nComment=An advanced download manager written in python\nEncoding=UTF-8\nType=Application\nCategories=Application;Network;\nExec=python %s\nTerminal=false\nIcon=%s" % (dest + "/sfdownloader.py",dest + "/img/logo.svg")
	file = open("/usr/share/applications/sfdownloader.desktop",'w')
	file.write(desktop)
	file.close()
	print "Done."

setup(name="SFDownloader",
	version="0.3",
	description="An advanced download manager written in python",
	author="Sven Festersen",
	author_email="sven@sven-festersen.de",
	url="http://downloader.sven-festersen.de",
	package_dir = {"sfdownloader":"src"},
	packages=["sfdownloader"],
	data_files=get_data_files()
	)
add_to_menu()
