#own modules
import icons
import misc
#standard modules
import gtk
import gobject
import md5
import os
import threading
import time
import urllib

class Input_thread(threading.Thread):
	def __init__(self,plugin,downloader,job):
		threading.Thread.__init__(self)
		self.plugin = plugin
		self.downloader = downloader
		self.job = job

	def run(self):
		dl = self.plugin.get_downloads()
		gtk.gdk.threads_enter()
		if len(dl) == 1:
			self.downloader.add_single_download(dl[0])
		elif len(dl) == 0:
			self.job.set_message(_("Error"))
		else:
			for x in dl:
				self.downloader.add_single_download(x)
		gtk.gdk.threads_leave()

class Load_thread(threading.Thread):
	def __init__(self,downloader,job_id,job,settings):
		threading.Thread.__init__(self)
		self.downloader = downloader
		self.settings = settings
		self.id = job_id
		self.job = job

	def run(self):
		time.sleep(1)
		added = 0
		for x in self.downloader.saved_downloads.getSections():
			if  self.downloader.saved_downloads.readFloat(x,"job_id") == self.id:
				dl = Single_download(x,self.id,self.downloader.saved_downloads.readString(x,"title",x),self.downloader,self.settings)
				dl.set_percentage(self.downloader.saved_downloads.readFloat(x,"percentage"))
				if self.downloader.saved_downloads.readBool(x,"done"):
					self.job.done((x,dl.get_temp_filename(),self.downloader.saved_downloads.readInt(x,"remote_size",0)))
				self.downloader.add_single_download(dl)
				added = added + 1
		if added == 0:
			self.job.set_message(_("Error"))


class Job:
	def __init__(self,id,downloader,input,input_params,output,output_params,get_downloads_new,settings):
		self.settings = settings
		self.id = id
		self.downloader = downloader
		self.input = input
		self.input_params = input_params
		self.output = output
		self.output_params = output_params
		self.downloads = []
		self.download_urls = []
		self.done_list = []
		self.iter = None
		self.is_donev = False
		self.downloaded_bytes = 0
		self.message = ""
		self.path = ()
		self.title = ""

		model = self.downloader.get_dl_list_model()
		list = self.downloader.get_dl_list()
		root = model.get_iter_root()
		img = None
		txt = _("Download")
		if self.input == "input_single":
			img = icons.pixbuf_from_iconname("unknown")
			txt = _("Simple Download")
		elif self.input == "input_gallery":
			img = icons.pixbuf_from_iconname("image-x-generic")
			txt = _("Gallery Download")
		elif self.input == "input_youtube":
			img = icons.pixbuf_from_iconname("video-x-generic")
			txt = _("YouTube Video Download")
		elif self.input == "input_distro":
			img = gtk.gdk.pixbuf_new_from_file("img/tux.png")
			txt = _("Linux Distribution Download")
		self.title = txt
		n = model.iter_n_children(root)
		self.iter = model.append(root)
		model.set(self.iter,0,img,1,txt,2,"",3,0,4,"",5,"",6,"")
		if n == 0:
			list.expand_row((0),False)

		if get_downloads_new:
			self.__get_downloads()
		else:
			self.__get_saved_downloads()

			
	def set_message(self,txt):
		self.message = txt
		
		
	def get_message(self):
		return self.message
		
	def get_title(self):
		return self.title

	def __get_downloads(self):
		self.input_plugin = self.downloader.inputs[self.input](self.input_params,self.id,self.downloader,self.settings)
		t = Input_thread(self.input_plugin,self.downloader,self)
		t.start()

	def __get_saved_downloads(self):
		self.settings.get_value("logger_main").info("Loading downloads for job id %s" % self.id)
		t = Load_thread(self.downloader,self.id,self,self.settings)
		t.start()

	def get_percentage(self):
		sum = 0.0
		n = 0
		for x in self.downloads:
			try:
				sum = sum + x.get_percentage()
				n = n + 1
			except:
				pass

		if n != 0:
			return sum/float(n)
		else:
			return 0.0

	def done(self,data):
		self.downloaded_bytes = self.downloaded_bytes + data[2]
		url = data[0]
		fn = data[1]
		if url in self.download_urls and not data in self.done_list:
			self.done_list.append(data)
		if len(self.downloads) == len(self.done_list) or self.get_percentage() == 1.0:
			self.downloader.saved_jobs.writeBool(str(self.id),"done",True)
			self.is_donev = True
			self.output_plugin = self.downloader.outputs[self.output](self.output_params,self.id,self.downloader,self.done_list,self.settings)
			self.downloader.history_show()

	def get_id(self):
		return self.id

	def add_dl(self,dl):
		self.downloads.append(dl)
		self.download_urls.append(dl.get_url())

	def is_done(self):
		return self.is_donev
		
	def get_download_count(self):
		return len(self.downloads)

class Single_download:
	def __init__(self,url,job_id,title,downloader,settings):
		self.settings = settings
		self.url = url
		self.job_id = job_id
		self.title = title
		self.thread = None
		self.downloader = downloader
		self.active = False
		self.settings.get_value("logger_main").info("Created new download '%s'." % self.title)
		fn = url.replace("/","-----") +"." + str(self.job_id)
		self.filename = self.settings.get_value("dir_download_temp") + "/" + fn
		self.remote_size = 0
		self.local_size = 0
		self.old_size = 0
		self.speed = -1
		self.percentage = 0.0
		self.stopped = False
		self.iter = None
		self.downloaded_bytes = 0
		self.message = ""
		self.path = ()
		self.error = None
		
	def set_message(self,txt):
		self.message = txt
		
	def get_message(self):
		return self.message
		
	def set_http_error(self,id):
		self.error = ("http",id)
		self.stopped = True
		errors = {401:_("Unauthorized (401)"),
				403:_("Forbidden (403)"),
				404:_("Not found (404)"),
				405:_("Method not allowed (405)"),
				408:_("Request time-out (408)"),
				500:_("Internal Server Error (500)"),
				503:_("Service unavailable (503)")}
		if id in errors:
			self.message = errors[id]
		else:
			self.message = _("Error")
		self.settings.get_value("logger_download").error(self.message)
		
		
	def add_downloaded_bytes(self,bytes):
		self.downloaded_bytes = self.downloaded_bytes + bytes
		
	def get_downladed_bytes(self):
		res = self.downloaded_bytes
		self.downloaded_bytes = 0
		return res

	def set_percentage(self,p):
		self.percentage = p
		self.downloader.saved_downloads.writeFloat(self.url,"percentage",p)

	def has_error(self):
		if self.thread != None:
			return self.thread.has_error()
		return False

	def is_stopped(self):
		return self.stopped

	def get_percentage(self):
		if self.thread != None and self.thread.has_error():
			return self.downloader.saved_downloads.readFloat(self.url,"percentage",0.0)
		return self.percentage

	def get_title(self):
		return self.title

	def is_active(self):
		return self.active

	def get_job_id(self):
		return self.job_id

	def get_url(self):
		return self.url
		
	def get_id(self):
		return self.url + "." + str(self.job_id)
		
	def set_status(self,status_id):
		#0: waiting, 1: connecting, 2: downloading, 3: done, 4: connected, -1: error
		status = self.settings.get_value("download_status")
		status[self.url + "." + str(self.job_id)] = status_id
		self.settings.set_value("download_status",status)
		
	def get_status(self):
		status = self.settings.get_value("download_status")
		if not  (self.url + "." + str(self.job_id)) in status:
			return 0
		else:
			return status[self.url + "." + str(self.job_id)]
			
	def delete_status(self):
		status = self.settings.get_value("download_status")
		del status[self.url + "." + str(self.job_id)]
		self.settings.set_value("download_status",status)

	def download(self):
		self.message = ""
		if not self.downloader.saved_downloads.readBool(self.url,"done",False):
			self.stopped = False
			self.thread = Downloader_thread(self.downloader,self,self.filename,self.settings)
			self.thread.start()
		else:
			self.percentage = 1.0
			self.set_status(3)
			
	def pause(self):
		if self.thread != None:
			self.thread.join(0.0)
			self.stopped = True
		self.speed = 0.0

	def get_size(self):
		if self.thread != None and self.thread.has_error():
			return (self.downloader.saved_downloads.readInt(self.url,"remote_size",0),self.downloader.saved_downloads.readInt(self.url,"local_size",0))
		return (self.remote_size,self.local_size)

	def get_local_size(self):
		if self.thread != None and self.thread.has_error():
			return self.downloader.saved_downloads.readInt(self.url,"local_size",0)
		return self.local_size

	def get_old_size(self):
		return self.old_size

	def set_remote_size(self,bytes):
		self.remote_size = bytes
		self.downloader.saved_downloads.writeInt(self.url,"remote_size",bytes)

	def set_local_size(self,bytes):
		self.local_size = bytes
		self.downloader.saved_downloads.writeInt(self.url,"local_size",bytes)

	def set_speed(self,sp):
		self.speed = sp

	def get_speed(self):
		return self.speed

	def set_active(self,active):
		self.active = active

	def set_stopped(self,stopped):
		self.stopped = stopped

	def get_size_diff(self):
		try:
			if os.path.exists(self.filename):
				old = self.old_size
				new = os.path.getsize(self.filename)
				self.old_size = new
				return new - old
		except:
			pass
		return 0

	def get_temp_filename(self):
		return self.filename

	def set_downloaded(self):
		self.downloader.saved_downloads.writeBool(self.url,"done",True)


class Range_url_opener(urllib.FancyURLopener):
	def __init__(self,download,download_thread):
		urllib.FancyURLopener.__init__(self)
		self.download = download
		self.download_thread = download_thread
		
	def http_error_206(self, url, fp, errcode, errmsg, headers, data=None):
		pass
		
	def http_error_401(self, url, fp, errcode, errmsg, headers, data=None):
		self.download_thread.set_error(True)
		self.download.set_http_error(401)
		
	def http_error_403(self, url, fp, errcode, errmsg, headers, data=None):
		self.download_thread.set_error(True)
		self.download.set_http_error(403)
		
	def http_error_404(self, url, fp, errcode, errmsg, headers, data=None):
		self.download_thread.set_error(True)
		self.download.set_http_error(404)
		
	def http_error_405(self, url, fp, errcode, errmsg, headers, data=None):
		self.download_thread.set_error(True)
		self.download.set_http_error(405)
		
	def http_error_408(self, url, fp, errcode, errmsg, headers, data=None):
		self.download_thread.set_error(True)
		self.download.set_http_error(408)
		
	def http_error_500(self, url, fp, errcode, errmsg, headers, data=None):
		self.download_thread.set_error(True)
		self.download.set_http_error(500)
		
	def http_error_503(self, url, fp, errcode, errmsg, headers, data=None):
		self.download_thread.set_error(True)
		self.download.set_http_error(503)

class Downloader_thread(threading.Thread):
	def __init__(self,downloader,download,filename,settings):
		threading.Thread.__init__(self)
		self.downloader = downloader
		self.download = download
		self.__stop_event = threading.Event()
		self.filename = filename
		self.error = False
		self.settings = settings

	def run(self):
		block_size = 4096#8192
		speed_iteration_count = 10
		speed_iteration_count_is = 1
		self.download.set_active(True)
		try:
			remote_size = 0
			self.download.set_status(1)
			self.loader = Range_url_opener(self.download,self)
			
			if os.path.exists(self.filename):
				file_handler = open(self.filename,"ab")
				local_size = os.path.getsize(self.filename)
				self.loader.addheader("Range","bytes=%s-" % local_size)
				self.remote_handler = self.loader.open(self.download.get_url())
				if "Content-Length" in self.remote_handler.headers:
					remote_size = int(self.remote_handler.headers["Content-Length"]) + local_size
			else:
				file_handler = open(self.filename,"wb")
				local_size = 0
				self.remote_handler = self.loader.open(self.download.get_url())
				if "Content-Length" in self.remote_handler.headers:
					remote_size = int(self.remote_handler.headers["Content-Length"])
			
			self.download.set_remote_size(remote_size)
			self.download.set_local_size(local_size)

			self.download.set_status(4)
			load = True
			if "Content-Length" in self.remote_handler.headers and int(self.remote_handler.headers['Content-Length']) == local_size:
				load = False

			self.download.set_status(2)
			self.error = False
			x = time.time()
			while load and not self.__stop_event.isSet():
				data = self.remote_handler.read(block_size)
				(a,b) = self.download.get_size()
				if self.download.get_local_size() < remote_size and self.download.get_local_size() + block_size > remote_size:
					self.download.set_local_size(remote_size)
					self.download.set_percentage(1.0)
				else:
					self.download.add_downloaded_bytes(block_size)
					self.download.set_local_size(b + block_size)
					if remote_size > 0:
						self.download.set_percentage(float(b)/float(remote_size))
				if not data:
					self.download.set_speed(0.0)
					break
				file_handler.write(data)
				speed_iteration_count_is = speed_iteration_count_is + 1
				if speed_iteration_count_is == speed_iteration_count:
					speed_iteration_count_is = 1
					y = time.time()
					d = y - x
					sp = (float(block_size)*speed_iteration_count)/d
					self.download.set_speed(sp)
					x = time.time()

			self.remote_handler.close()
			file_handler.close()

			if not self.__stop_event.isSet():
				self.download.set_status(3)
				self.download.set_stopped(True)
				self.download.set_downloaded()
				self.downloader.get_job(self.download.get_job_id()).done((self.download.get_url(),self.filename,remote_size))
		except:
			self.settings.get_value("logger_main").error("Error downloading '%s'." % self.download.get_url())
			self.download.set_status(-1)
			self.error = True
			self.download.set_stopped(True)
		self.download.set_active(False)

	def join(self,timeout=None):
		self.download.set_status(0)
		self.__stop_event.set()
		self.download.set_active(False)
		threading.Thread.join(self, timeout)
		
	def set_error(self,e):
		self.error = e
		self.__stop_event.set()

	def has_error(self):
		return self.error
