#!/usr/bin/env python
import gtk
import os

ext_icons = {".jpg":"gnome-mime-image-jpeg",".jpeg":"gnome-mime-image-jpeg",
			".zip":"gnome-mime-application-zip",".tar":"gnome-mime-application-x-tar",
			".jar":"gnome-mime-application-x-jar",".rar":"gnome-mime-application-x-rar",
			".gz":"gnome-mime-application-x-gzip",".deb":"gnome-mime-application-x-deb",
			".rpm":"gnome-mime-application-x-rpm",".iso":"package-x-generic",
			".flv":"video-x-generic",".mpg":"video-x-gerenic",".mpeg":"video-x-gerenic",
			".avi":"video-x-gerenic",".mp3":"audio-x-generic",".ogg":"audio-x-generic",
			".wav":"audio-x-generic"}

def get_file_icon(filename):
	ext = os.path.splitext(filename)
	ext = ext[1]
	if ext in ext_icons:
		return pixbuf_from_iconname(ext_icons[ext])
	else:
		return pixbuf_from_iconname("unknown")

def get_icon(name,size=16):
	info = gtk.icon_theme_get_default()
	return info.lookup_icon(name,size,gtk.ICON_LOOKUP_FORCE_SVG)
	
def get_icon_path(name,size=16):
	icon = get_icon(name,size)
	if icon != None:
		return icon.get_filename()
	return None
	
def pixbuf_from_iconname(name,size=16):
	try:
		info = gtk.icon_theme_get_default()
		return info.load_icon(name,size,gtk.ICON_LOOKUP_FORCE_SVG)
	except:
		info = gtk.icon_theme_get_default()
		return info.load_icon("unknown",size,gtk.ICON_LOOKUP_FORCE_SVG)
