#! /usr/bin/env python
#own modules
import download
import icons
import misc
#standard modules
import os
import shutil
import pygtk
import gtk
import gtk.glade
import time
import urllib
pygtk.require("2.0")

class Input_gallery_window:
	def __init__(self,downloader,settings,fn_zerofill=2):
		self.settings = settings
		self.downloader = downloader
		self.fn_zerofill = fn_zerofill
		self.wTree = gtk.glade.XML( "sfdownloader.glade","input_gallery")
		self.callbacks = {"on_button_cancel_clicked":self.__callback_cancel,
									  "on_button_download_clicked":self.__callback_download}
		self.wTree.get_widget("entry_zerofill").set_activates_default(True)
		self.wTree.get_widget("input_gallery").set_icon(icons.pixbuf_from_iconname("image-x-generic"))
		self.wTree.signal_autoconnect (self.callbacks)
		self.clipboard = gtk.Clipboard()
		self.clipboard.request_text(self.__callback_clipboard)

	#callbacks
	def __callback_download(self,widget):
		url = self.wTree.get_widget("entry_url").get_text()
		if not url.startswith("http://"):
			url = "http://" + url
		safe_url = url.replace("/","-")
		zerofill = self.wTree.get_widget("entry_zerofill").get_value()
		safe_url = safe_url[:safe_url.rfind("-")]
		gal = self.settings.get_value("dir_download_gallery")
		gal = gal[gal.rfind("/")+1:]
		if self.wTree.get_widget("select_output_single_keep").get_active():
			self.downloader.add_job("input_gallery",[url,zerofill],"output_single",[])
		elif self.wTree.get_widget("select_output_single_dir").get_active():
			self.downloader.add_job("input_gallery",[url,zerofill],"output_single",["[str]dir="+gal+"/"+safe_url,"[bool]enumerate_replace=True","[int]zerofill=%s" % self.fn_zerofill])
		elif self.wTree.get_widget("select_output_single_dir_keep").get_active():
			self.downloader.add_job("input_gallery",[url,zerofill],"output_single",["[str]dir="+gal+"/"+safe_url])
		elif self.wTree.get_widget("select_output_html").get_active():
			self.downloader.add_job("input_gallery",[url,zerofill],"output_gallery",["[str]dir="+gal+"/"+safe_url])
		self.wTree.get_widget("input_gallery").destroy()

	def __callback_cancel(self,widget):
		self.wTree.get_widget("input_gallery").destroy()

	def __callback_clipboard(self,clipboard,text,data):
		if text != None and text.startswith("http://"):
			if text.find("0001.jpg") != -1:
				text = text.replace("0001.jpg","%n.jpg")
				self.wTree.get_widget("entry_zerofill").set_value(4)
			elif text.find("001.jpg") != -1:
				text = text.replace("001.jpg","%n.jpg")
				self.wTree.get_widget("entry_zerofill").set_value(3)
			elif text.find("01.jpg") != -1:
				text = text.replace("01.jpg","%n.jpg")
				self.wTree.get_widget("entry_zerofill").set_value(2)
			elif text.find("1.jpg") != -1:
				text = text.replace("1.jpg","%n.jpg")
				self.wTree.get_widget("entry_zerofill").set_value(1)
			self.wTree.get_widget("entry_url").set_text(text)

class Input_gallery:
	def __init__(self,params,job_id,downloader,settings):
		self.settings = settings
		self.url = params[0]
		self.zerofill = int(float(params[1]))
		self.job_id = job_id
		self.downloader = downloader

	def get_downloads(self):
		time.sleep(0.5)
		self.downloader.get_job(self.job_id).set_message(_("Checking URLs..."))
		dls = []
		exists = True
		i = 1
		failed = 0
		old = ""
		while 1 == 1:
			u = self.url.replace("%n",misc.zerofill(str(i),self.zerofill))
			f = urllib.urlopen(u)
			if u == old:
				break
			if f.info().getmaintype() != "image":
				failed = failed + 1
				if failed == 5:
					break
			else:
				dls.append(download.Single_download(u,self.job_id,u,self.downloader,self.settings))
				failed = 0
			i = i + 1
			old = u
		self.downloader.get_job(self.job_id).set_message("")
		return dls
