#! /usr/bin/env python
#own modules
import download
import icons
#standard modules
import pygtk
import gtk
import gtk.glade
import time
pygtk.require("2.0")

def zerofill(i,n):
	i = str(i)
	while len(i) < n:
		i = "0" + i
	return i

class Input_single_window:
	def __init__(self,downloader,settings):
		self.settings = settings
		self.downloader = downloader
		self.wTree = gtk.glade.XML( "sfdownloader.glade","input_single")
		self.callbacks = {"on_button_download_clicked":self.__callback_download,
					"on_button_cancel_clicked":self.__callback_cancel,
					"on_select_output_as_toggled":self.__callback_select_output_as_toggled,
					"on_button_save_as_clicked":self.__callback_select_save_as}
		self.wTree.signal_autoconnect (self.callbacks)
		self.wTree.get_widget("input_single").set_icon(icons.pixbuf_from_iconname("unknown"))
		self.clipboard = gtk.Clipboard()
		self.clipboard.request_text(self.__callback_clipboard)

	#callbacks
	def __callback_download(self,widget):
		url = self.wTree.get_widget("entry_url").get_text()
		if not url.startswith("http://"):
			url = "http://" + url
		if self.wTree.get_widget("select_output_single").get_active():
			self.downloader.add_job("input_single",[url],"output_single",[])
		elif self.wTree.get_widget("select_output_as").get_active():
			fn = self.wTree.get_widget("entry_save_as").get_text()
			self.downloader.add_job("input_single",[url],"output_single",["[str]dir="+fn[:fn.rfind("/")],"[str]filename="+fn[fn.rfind("/")+1:]])
		
		self.wTree.get_widget("input_single").destroy()

	def __callback_cancel(self,widget):
		self.wTree.get_widget("input_single").destroy()

	def __callback_clipboard(self,clipboard,text,data):
		if text != None and text.startswith("http://"):
			self.wTree.get_widget("entry_url").set_text(text)
	
	def __callback_select_output_as_toggled(self,widget):
		if self.wTree.get_widget("select_output_as").get_active():
			self.wTree.get_widget("entry_save_as").set_sensitive(True)
			self.wTree.get_widget("button_save_as").set_sensitive(True)
		else:
			self.wTree.get_widget("entry_save_as").set_sensitive(False)
			self.wTree.get_widget("button_save_as").set_sensitive(False)
			
	def __callback_select_save_as(self,widget):
		fc = gtk.FileChooserDialog(action=gtk.FILE_CHOOSER_ACTION_SAVE,buttons=((gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_OK, gtk.RESPONSE_ACCEPT)))
		fc.run()
		fn = fc.get_filename()
		fc.destroy()
		if fn != None:
			self.wTree.get_widget("entry_save_as").set_text(fn)


class Input_single:
	def __init__(self,params,job_id,downloader,settings):
		self.settings = settings
		self.url = params[0]
		self.job_id = job_id
		self.downloader = downloader

	def get_downloads(self):
		time.sleep(0.5)
		self.downloader.get_job(self.job_id).set_message(_("Checking URL..."))
		dl = download.Single_download(self.url,self.job_id,self.url,self.downloader,self.settings)
		self.downloader.get_job(self.job_id).set_message("")
		return [dl]
