import popen2
import re
import gtk
import icons
import os
import pygtk
import threading
import time

def round2(z,i):
	if z < 0.0:
		z = 0.0 
	return round(z,i)
	
def format_size(s):
	s = misc.round2(s,2)
	if s < 1024:
		return "%s Bytes" % s
	elif s >= 1024 and s < 1024*1024:
		return "%s KB" % misc.round2((s/1024),2)
	elif s >= 1024*1024 and s < 1024*1024*1024:
		return "%s MB" % misc.round2((s/1024/1024),2)
	elif s >= 1024*1024*1024 and s < 1024*1024*1024*1024:
		return "%s GB" % misc.round2((s/1024/1024/1024),2)

def app_installed(app_name,obj=None):
	res = False
	if obj == None or (obj != None and not obj.is_set("app_installed_%s" % app_name)):
		appInstance = popen2.Popen3("whereis %s" % app_name)
		appInstance.tochild.close()
		try:
			appInstance.wait()
		except:
			pass
			
		result = appInstance.fromchild.readlines()[0]
		a = result.split(":")
		if len(a) > 1:
			result = a[1].strip()
			if result != "":
				res = True
		
		if obj != None:
			obj.set_value("app_installed_%s" % app_name,res)
		appInstance.tochild.close()
		appInstance.wait()
		appInstance.fromchild.close()
	elif obj != None and obj.is_set("app_installed_%s" % app_name):
		return obj.get_value("app_installed_%s" % app_name)
	
	return res

def param_list_to_dict(l,default={}):
	res = default
	for x in l:
		if x.find("=") != -1:
			a = x.split("=",1)
			if x.startswith("[int]"):
				res[a[0][len("[int]"):]] = int(a[1])
			elif x.startswith("[float]"):
				res[a[0][len("[float]"):]] = float(a[1])
			elif x.startswith("[bool]"):
				res[a[0][len("[bool]"):]] = (a[1] == "True")
			elif x.startswith("[str]"):
				res[a[0][len("[str]"):]] = str(a[1])
			else:
				res[a[0]] = a[1]
	return res
	
def zerofill(i,n):
	i = str(i)
	while len(i) < n:
		i = "0" + i
	return i
	
def url_matches_filter(filter,url):
	if filter == []:
		return True
	else:
		for pattern in filter:
			r = re.compile(pattern)
			if r.match(url) != None:
				return True
	return False
	
def get_ffmpeg_encoders():
	audio = []
	video = []
	if app_installed("ffmpeg"):
		appInstance = popen2.Popen3("ffmpeg -formats")
		appInstance.tochild.close()
		try:
			appInstance.wait()
		except:
			pass
			
		result = appInstance.fromchild.readlines()
		codecs = False
		for x in result:
			if x.strip() == "Codecs:":
				codecs = True
			if codecs:
				if len(x) > 4 and x[2] == "E" and x[3] == "A":
					c = x[7:]
					c = c.strip()
					audio.append(c)
				elif len(x) > 4 and x[2] == "E" and x[3] == "V":
					c = x[7:]
					c = c.strip()
					video.append(c)
				if x.strip() == "":
					codecs = False
			
		appInstance.tochild.close()
		appInstance.wait()
		appInstance.fromchild.close()
	
	return (audio,video)


class Global_settings:
	def __init__(self):
		self.data = {}
		
	def set_value(self,key,value):
		self.data[key] = value
		
	def get_value(self,key):
		if key in self.data:
			return self.data[key]
		return None
		
	def is_set(self,key):
		return (key in self.data)
		



def image_menu_item_from_stock(stock_id,text):
	item = gtk.ImageMenuItem(stock_id)
	item.get_child().set_label(text)
	return item
	
def image_menu_item_from_file(filename,text):
	if gtk.stock_lookup(filename) == None:
		iconset = gtk.IconSet(gtk.gdk.pixbuf_new_from_file(filename))
		factory = gtk.IconFactory()
		factory.add(filename,iconset)
		factory.add_default()
	item = gtk.ImageMenuItem(filename)
	item.get_child().set_label(text)
	return item
	
def image_menu_item_from_name(name,text):
	return image_menu_item_from_file(icons.get_icon_path(name),text)

def format_size(s):
	s = round(s,2)
	if s < 1024:
		return "%s Bytes" % s
	elif s >= 1024 and s < 1024*1024:
		return "%s KB" % round((s/1024),2)
	elif s >= 1024*1024 and s < 1024*1024*1024:
		return "%s MB" % round((s/1024/1024),2)
	elif s >= 1024*1024*1024 and s < 1024*1024*1024*1024:
		return "%s GB" % round((s/1024/1024/1024),2)


class Id_tree:
	def __init__(self,id,parent=None):
		self.id = str(id)
		self.children = {}
		self.parent = parent
		
	def get_id(self):
		return self.id
		
	def add_child(self,child):
		self.children[len(self.children)] = child
		
	def remove_child(self,id):
		id = str(id)
		n = -1
		for (x,y) in self.children.iteritems():
			if y.get_id() == id:
				del self.children[x]
				n = x
				break
		if n != -1:
			for (x,y) in self.children.copy().iteritems():
				if x > n:
					del self.children[x]
					self.children[x-1] = y
		if n == -1:
			for (x,y) in self.children.copy().iteritems():
				y.remove_child(id)
					
	def get_children(self):
		return self.children
		
	def get_child_by_id(self,id):
		for (x,y) in self.children.iteritems():
			if y.get_id() == str(id):
				return y
		return None
		
	def add_child_to_child(self,new_child,id):
		id = str(id)
		for (x,y) in self.children.iteritems():
			if y.get_id() == id:
				y.add_child(new_child)
				break
				
	def get_id_by_path(self,path,n=0):
		if n < len(path) - 1:
			return self.children[path[n+1]].get_id_by_path(path,n+1)
		elif n == len(path) - 1:
			return self.id
		return None


