import os
import shutil
import misc

class Output_gallery:
	def __init__(self,params,job_id,downloader,filenames,settings):
		self.settings = settings
		self.params = params
		self.downloader = downloader
		self.job_id = job_id
		self.num = 1
		self.cfiles = []
		self.meta = []
		self.url = ""
		
		self.options = {"dir":self.settings.get_value("dir_download_main"),
					"enumerate":False,
					"enumerate_replace":True,
					"zerofill":4,
					"filename":""}
					
		self.options = misc.param_list_to_dict(params,self.options)
		
		if self.options["dir"][0] != "/":
			self.options["dir"] = self.settings.get_value("dir_download_main") + "/" + self.options["dir"]
		
		filenames.sort()
		if not os.path.exists(self.options["dir"]):
			os.makedirs(self.options["dir"])

		self.downloader.get_job(self.job_id).set_message(_("Moving files"))
		url = filenames[0][0]
		self.url = url[:url.rfind("/")]
		for x in filenames:
			self.__move(x[0],x[1])
		
		self.downloader.get_job(self.job_id).set_message(_("Creating HTML gallery"))
		self.create_thumbs()
		self.create_html()
		self.downloader.get_job(self.job_id).set_message("")
		
		self.downloader.meta_files_add(self.meta)

	def __move(self,url,temp_filename):
		dir = self.options["dir"]
		target_filename = dir + "/" + url[url.rfind("/")+1:]
		if self.options["enumerate_replace"]:
			(base,ext) = os.path.splitext(target_filename)
			target_filename = dir + "/" + misc.zerofill(self.num,self.options["zerofill"]) + ext
			self.cfiles.append(misc.zerofill(self.num,self.options["zerofill"]) + ext)
			self.num = self.num + 1
		elif self.options["enumerate"]:
			(base,ext) = os.path.splitext(target_filename)
			target_filename = dir + "/" + base + misc.zerofill(self.num,self.options["zerofill"]) + ext
			self.cfiles.append(misc.zerofill(base + self.num,self.options["zerofill"]) + ext)
			self.num = self.num + 1
		try:
			self.downloader.history_add(url,target_filename)
			shutil.move(temp_filename,target_filename)
			self.meta.append({"path":target_filename,"url":url,"size":os.path.getsize(target_filename),"date":time.time()})
		except:
			pass
			
			
	def create_thumbs(self):
		if not os.path.exists(self.options["dir"] + "/.thumbs"):
			os.mkdir(self.options["dir"] + "/.thumbs")
		from PIL import Image
		for x in self.cfiles:
			try:
				img = Image.open(self.options["dir"] + "/" + x)
				img.thumbnail((200,200),Image.ANTIALIAS)
				img.save(self.options["dir"] + "/.thumbs/" + x)
			except:
				pass

	def create_html(self):
		
		html = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">\n<head>\n\t<title>Gallery - " + self.url + "</title>\n\t<meta http-equiv=\"content-type\" content=\"text/html;charset=utf-8\" />\n</head>\n<body style=\"font-family: sans-serif; font-size: 12px;\">\n"
		html = html + "\t<div style=\"width: 700px; margin: auto;\">\n"
		html = html + "\t\t<table>\n"
		
		columns = 3
		i = 1
		created_by = _("Created by")
		
		for x in self.cfiles:
			size = _("Size: ") + misc.format_size(os.path.getsize(self.options["dir"] + "/" + x))
			filename = _("Filename: ") + x
			
			if i == 1:
				html = html + "\t\t\t<tr>\n"
			
			html = html + "\t\t\t\t<td>"
			html = html + "\t\t\t\t\t<a href=\"" + x + "\"><img style=\"border-width: 0px;\" src=\".thumbs/" + x + "\" title=\"" + x + "\" /></a><br />\n"
			html = html + "\t\t\t\t\t" + filename + "<br />\n"
			html = html + "\t\t\t\t\t" + size + "\n"
			html = html + "\t\t\t\t</td>\n"
			
			if i == columns:
				html = html + "\t\t\t</tr>\n"
				i = 1
			else:
				i = i + 1
				
		while i < columns + 1:
			html = html + "\t\t\t\t<td></td>\n"
			if i == columns:
				html = html + "\t\t\t</tr>\n"
			i = i + 1
			
		html = html + "\t\t</table>\n"
		
		html = html + "\t\t<div style=\"margin-top: 10px; border-top: 1px #424242 solid; clear: both;\">\n\t\t\t<p>" + created_by + " <a href=\"http://downloader.sven-festersen.de\">" + self.downloader.app_name + "</a>.</p>\n\t\t</div>\n"
		html = html + "\t</div>\n"
		html = html + "</body>\n</html>"
		html_doc = open(self.options["dir"] + "/gallery.html","w")
		html_doc.write(html)
		html_doc.close()
