import os
import shutil
import time
import misc

class Output_single:
	def __init__(self,params,job_id,downloader,filenames,settings):
		self.settings = settings
		self.params = params
		self.downloader = downloader
		self.job_id = job_id
		self.num = 1
		self.meta = []
		
		self.options = {"dir":self.settings.get_value("dir_download_main"),
					"enumerate":False,
					"enumerate_replace":False,
					"zerofill":2,
					"filename":""}
					
		self.options = misc.param_list_to_dict(params,self.options)
		
		if self.options["dir"][0] != "/":
			self.options["dir"] = self.settings.get_value("dir_download_main") + "/" + self.options["dir"]
		
		filenames.sort()
		if not os.path.exists(self.options["dir"]):
			os.makedirs(self.options["dir"])

		self.downloader.get_job(self.job_id).set_message(_("Moving files"))
		for x in filenames:
			self.__move(x[0],x[1])
		self.downloader.get_job(self.job_id).set_message("")
		
		self.downloader.meta_files_add(self.meta)

	def __move(self,url,temp_filename):
		dir = self.options["dir"]
		if self.options["filename"] == "":
			self.options["filename"] = url[url.rfind("/")+1:]
		target_filename = dir + "/" + self.options["filename"]
		if self.options["enumerate_replace"]:
			(base,ext) = os.path.splitext(target_filename)
			target_filename = dir + "/" + misc.zerofill(self.num,self.options["zerofill"]) + ext
			self.num = self.num + 1
		elif self.options["enumerate"]:
			(base,ext) = os.path.splitext(target_filename)
			target_filename = dir + "/" + base + misc.zerofill(self.num,self.options["zerofill"]) + ext
			self.num = self.num + 1
		try:
			self.downloader.history_add(url,target_filename)
			shutil.move(temp_filename,target_filename)
			self.meta.append({"path":target_filename,"url":url,"size":os.path.getsize(target_filename),"date":time.time()})
		except:
			pass
