#own modules
import misc
#python modules
import os
import time
import shutil

class Output_video:
	def __init__(self,params,job_id,downloader,filenames,settings):
		self.settings = settings
		self.params = params
		self.downloader = downloader
		self.job_id = job_id
		self.num = 1
		self.cfiles = []
		self.meta = []
		
		self.options = {"dir":self.settings.get_value("dir_download_main"),
					"enumerate":False,
					"enumerate_replace":False,
					"zerofill":2,
					"filename":"",
					"video-codec":"xvid",
					"video-bitrate":2000,
					"audio-codec":"mp3",
					"audio-bitrate":192,
					"size":"320x240",
					"ext":".avi"}

		self.options = misc.param_list_to_dict(params,self.options)

		
		if self.options["dir"][0] != "/":
			self.options["dir"] = self.settings.get_value("dir_download_main") + "/" + self.options["dir"]
		
		filenames.sort()
		if not os.path.exists(self.options["dir"]):
			os.makedirs(self.options["dir"])

		self.downloader.get_job(self.job_id).set_message(_("Moving files"))
		for x in filenames:
			self.__move(x[0],x[1])
		self.downloader.get_job(self.job_id).set_message("")

		for x in self.cfiles:
			self.convert_video(x)
			
		self.downloader.meta_files_add(self.meta)

	def __move(self,url,temp_filename):
		dir = self.options["dir"]
		if self.options["filename"] == "":
			self.options["filename"] = url[url.rfind("/")+1:]
		target_filename = dir + "/" + self.options["filename"]
		if self.options["enumerate_replace"]:
			(base,ext) = os.path.splitext(target_filename)
			target_filename = dir + "/" + misc.zerofill(self.num,self.options["zerofill"]) + ext
			self.num = self.num + 1
		elif self.options["enumerate"]:
			(base,ext) = os.path.splitext(target_filename)
			target_filename = dir + "/" + base + misc.zerofill(self.num,self.options["zerofill"]) + ext
			self.num = self.num + 1
		try:
			self.downloader.history_add(url,target_filename)
			self.cfiles.append(target_filename)
			shutil.move(temp_filename,target_filename)
			self.meta.append({"path":target_filename,"url":url,"size":os.path.getsize(target_filename),"date":time.time()})
		except:
			pass
			
			
	def convert_video(self,x):
		self.downloader.get_job(self.job_id).set_message(_("Converting video"))
		fn = x
		(base,ext) = os.path.splitext(fn)

		if ext == ".flv":
			#flv input - youtube etc.
			ffmpeg_opts = ["ffmpeg","-i",fn,"-b",str(self.options["video-bitrate"]),"-sameq","-pass","1","-vcodec",self.options["video-codec"],"-acodec",self.options["audio-codec"],"-ab",str(self.options["audio-bitrate"]),"-ar","44100","-s",self.options["size"],"%s%s" % (base,self.options["ext"])]
			
		if misc.app_installed("ffmpeg"):
			if os.path.exists("%s%s" % (base,self.options["ext"])):
				os.unlink("%s%s" % (base,self.options["ext"]))
			res = os.spawnvp(os.P_WAIT,"ffmpeg",ffmpeg_opts)
		if res == 0:
			self.meta.append({"path":"%s%s" % (base,self.options["ext"]),"url":"","size":os.path.getsize("%s%s" % (base,self.options["ext"])),"date":time.time()})
			self.downloader.get_job(self.job_id).set_message("")
		else:
			self.downloader.get_job(self.job_id).set_message(_("Error converting video"))
