#! /usr/bin/env python
#own modules

#standard modules
import pygtk
import gtk
import gtk.glade
import gobject
pygtk.require("2.0")

class Window_settings:
	def __init__(self,downloader,settings):
		self.downloader = downloader
		self.settings = settings
		self.wTree = gtk.glade.XML("sfdownloader.glade","window_settings")
		self.get_settings()
		self.callbacks = {"on_button_cancel_clicked":self.__callback_button_cancel_clicked,
					"on_button_save_clicked":self.__callback_button_save_clicked}
		self.wTree.signal_autoconnect (self.callbacks)
		
	def get_settings(self):
		self.wTree.get_widget("search_folder_dl").set_current_folder(self.settings["app_dl_dir"])
		self.wTree.get_widget("search_folder_temp").set_current_folder(self.settings["app_temp_dir"])
		self.wTree.get_widget("entry_dl_num").set_value(self.settings["app_max_dl_n"])
		self.wTree.get_widget("select_cleanup").set_active(self.settings["app_cleanup"])
		self.wTree.get_widget("entry_gal_dir").set_text(self.settings["gallery_dl_dir"])
		self.wTree.get_widget("entry_vid_dir").set_text(self.settings["video_dl_dir"])
		
	def make_settings(self):
		settings = {"app_dl_dir":self.wTree.get_widget("search_folder_dl").get_current_folder(),
				"app_temp_dir":self.wTree.get_widget("search_folder_temp").get_current_folder(),
				"app_max_dl_n":int(float(self.wTree.get_widget("entry_dl_num").get_value())),
				"app_cleanup":self.wTree.get_widget("select_cleanup").get_active(),
				"gallery_dl_dir":self.wTree.get_widget("search_folder_dl").get_current_folder()+"/"+self.wTree.get_widget("entry_gal_dir").get_text(),
				"video_dl_dir":self.wTree.get_widget("search_folder_dl").get_current_folder()+"/"+self.wTree.get_widget("entry_vid_dir").get_text()}
		return settings

	#callbacks
	def __callback_button_cancel_clicked(self,widget):
		self.wTree.get_widget("window_settings").destroy()
		
	def __callback_button_save_clicked(self,widget):
		self.downloader.save_settings(self.make_settings())
		self.wTree.get_widget("window_settings").destroy()
