#! /usr/bin/env python
#own modules

#standard modules
import pygtk
import gtk
import gtk.glade
import gobject
pygtk.require("2.0")
import threading
import time

class Window_statistics:
	def __init__(self,downloader):
		self.downloader = downloader
		self.wTree = gtk.glade.XML( "sfdownloader.glade","window_statistics")
		self.callbacks = {"on_button_close_clicked":self.__callback_button_close_clicked}
		self.wTree.signal_autoconnect (self.callbacks)
		self.thread = Update_thread(self)
		self.thread.start()
		
	def update_statistics(self):
		data = self.downloader.get_data_amounts()
		self.wTree.get_widget("label_all").set_label(data[0])
		self.wTree.get_widget("label_session").set_label(data[1])
		time.sleep(1)

	#callbacks
	def __callback_button_close_clicked(self,widget):
		self.thread.join()
		self.wTree.get_widget("window_statistics").destroy()

class Update_thread(threading.Thread):
	def __init__(self,window):
		threading.Thread.__init__(self)
		self.window = window
		self.__stop_event = threading.Event()

	def run(self):
		while not self.__stop_event.isSet():
			self.window.update_statistics()
			time.sleep(0.5)

	def join(self,timeout=None):
		self.__stop_event.set()
		threading.Thread.join(self, timeout)
